//MyQQ Defines
#ifndef _MYQQDEF_H
#define _MYQQDEF_H

#ifdef __WIN32__
typedef unsigned int uint;
typedef unsigned short ushort;
#define STDCALL __stdcall

#ifdef MYQQLIB
#define EXPORT __declspec(dllexport) STDCALL 
#else
#define EXPORT __declspec(dllimport) STDCALL
#endif

#else
#define EXPORT
#define STDCALL
#endif

#define MAX_PASSWORD 32

#define LM_OFFLINE	0
#define LM_NORMAL	1
#define LM_HIDDEN	2
#define LM_AWAY	3

#define ST_OFFLINE	0
#define ST_LOGGING	1
#define ST_REDIRECT	2	//¼
#define ST_WRPASS	6	//
#define ST_ONLINE	3
#define ST_ERROR	9	//


#define MAX_BUDDY		512
#define MAX_GROUP		100
#define MAX_BUDDY_INFO	45
#define BUDDY_INFO_LEN	256
#define MAX_NAME_LEN		64
#define GROUP_NOTICE_LEN	256
#define GROUP_DESC_LEN	256
#define MAX_GROUP_MEMBER	300

//delegaters
typedef void (STDCALL* messenger) ( uint uid, char* nick, time_t time, char* msg );
typedef void (STDCALL* group_messenger) ( uint uid, char* nick, uint int_uid, char* group_name,
	time_t time, char* msg );
typedef void (STDCALL*newstatus) ( uint uid, char* nick, int status );
//////////////////////////////////////////////////////////////
//             ** EXTERN FUNCTIONS **
//
/* ¼ */
EXPORT int myqq_login( int qid, uint uid, char* password, int mode );
/* ע */
EXPORT void myqq_logout( int qid );
/* ı״̬ LM_NORMAL LM_AWAY: 뿪 LM_HIDDEN */
EXPORT void myqq_change_status( int qid, int mode );
/* ȡ״ֵ̬ȡֵͬϵĲȡֵ */
EXPORT int myqq_get_status( int qid );
/* Ϣ */
EXPORT int myqq_send_im_to_buddy( int qid, uint uid, char* msg, int wait );
/* ϢȺ */
EXPORT int myqq_send_im_to_group( int qid, uint int_uid, char* msg, int wait );
/* ȡб */
EXPORT int myqq_get_buddy_list( int qid, char* buf, int size, char online );
/* ȡȺб */
EXPORT int myqq_get_group_list( int qid, char* buf, int size );
/* ȡȺԱб */
EXPORT int myqq_get_group_member_list( int qid, uint int_uid, char* buf, int size, char online );
/* úϢ֪ͨĻص */
EXPORT void myqq_delegate_buddy_msg( int qid, messenger msgr );
/* ȺϢ֪ͨĻص */
EXPORT void myqq_delegate_group_msg( int qid, group_messenger msgr );
/* ú״̬ı֪ͨĻص */
EXPORT void myqq_delegate_buddy_status( int qid, newstatus msgr );
/* ȡϢ */
EXPORT int myqq_get_buddy_info( int qid, uint uid, char* buf, int size );
/* ȡȺϢ */
EXPORT int myqq_get_group_info( int qid, uint uid, char* buf, int size );
/* ɺIDȡ */
EXPORT const char* myqq_get_buddy_name( int qid, uint uid );
/* ȺIDȡ */
EXPORT const char* myqq_get_group_name( int qid, uint int_uid );
/* ºбߺб */
EXPORT void myqq_update_buddy_list( int qid );
/* ȺϢȺԱȺ߳ԱϢ */
EXPORT void myqq_update_group_list( int qid );
/* ȴݰ */
EXPORT int myqq_wait( int qid, int sec ); //wait for every packet is sent out.
/* ʼMyQQݣʹ֮ǰ */
EXPORT int myqq_init(); //initialize the data, and return a qid
/* ͷMyQQݣڲʹʱ */
EXPORT void myqq_cleanup( int qid );
//

#endif //_MYQQ_H
